c
c plane frame element ************************************* 7/21/1996
c
      program frame
c
c ***************************** D A T A *****************************
c data in 'frame.dat'; f[^ frame.dat Ƃt@Cɍ쐬
c
c     (1) title (a70)       : title = title of a job
c                                     ̃^Cg 70 ȓ
c                                   = 'end' at the end of all jobs
c                                     ׂĂ̍Ō end ̎O
c     (2) node,nel,ee       : node = # of nodes; ߓ_
c               (2i5,f10.0)   nel  = # of elements; vf
c                             ee   = basic Young-s modulus E0
c                                    Ŝ̊{ƂȂ郄O
c     (3) x,z(2f10.0)       : x    = x-coordinate of a node
c                                          x = horizontal to the right
c                                    E̐ߓ_Wl
c                             z    = z-coordinate of a node
c                                          z = vertical downward
c                                    ̐ߓ_Wl
c         need 'node' sets of (3); ꂪɑߓ_sKvɂȂ
c     (4) i,j,re,area,smom  : i,j  = node no. of an element
c                                    vf̍E[ߓ_̐ߓ_ԍ
c              (2i5,3f10.0)   re   = Young-s modulus ratio; E/E0
c                                    ̊{OƂ̔䗦
c                             area = Cross-sectional area
c                                    ̗vf̒fʐ
c                             smom = Sectional moment of inertia
c                                    ̗vf̒fʓ񎟃[g
c         need 'nel' sets of (4); ꂪɑvfsKvɂȂ
c     (5) ndis(i5)          : ndis = # of displacement B.C.s
c                                    ψʂ^鋫E
c     (6) j,k,ff(2i5,f10.0) : j    = node no. of given displacement B.C.
c                                    ψʂ^ߓ_̔ԍ
c                             k    = displ. component(1=x-dir, 2=z-dir
c                                                        3=r-dir)
c                                    ̐ߓ_ŌŒ肷ψʐ̕
c                                    Ȃ 1, Ȃ 2
c                                                          ]Ȃ 3
c                             ff   = its value
c                                    (r-dir positive in counterclockwise)
c                                    ȂEɂl
c                                    Ȃ牺ɂl
c                                    ݊p͔v𐳂Ƃl
c         need 'ndis' sets of (6); ꂪ ndis sKvɂȂ
c     (7) nforc(i5)         : nforc= # of given-force B.C.s
c                                    O͂^鋫E
c     (8) j,k,ff(2i5,f10.0) : j    = node no. of given-force B.C.
c                                    O͂^ߓ_̔ԍ
c                             k    = force component(1=x-dir, 2=z-dir)
c                                                        3=r-dir)
c                                    ̐ߓ_ŗ^O͂̕
c                                    Ȃ 1, Ȃ 2
c                                                          ]Ȃ 3
c                             ff   = its value
c                                    (r-dir positive in counterclockwise)
c                                    ȂEɂāCO͂̒l
c                                    Ȃ牺ɂāCO͂̒l
c                                    [g͔v𐳂Ƃl
c         need 'nforc' sets of (8); ꂪ nforc sKvɂȂ
c     (9) ndist(i5)         : ndist= # of elements /w distributed load
c                                    uniform and only in the z direction
c                                    z ̓zO͂^vf
c    (10) j,ff(i5,f10.0)    : j    = element no. with distibuted load
c                                    zO͂pĂvfԍ
c                             ff   = its value
c                                    ɂl
c         need 'ndist' sets of (10); ꂪ ndist sKvɂȂ
c
c     (1)-(10) ЂƂ̖ɑ΂ZbgŁCZbgłׂĂ悢
c     Cframe.dat ̍ŏIs͍l߂ end Ƃ
c
c ************************ P R O G R A M ****************************
c
      parameter (mtop=8000)
c ************************* max. for 16-bit PC = 8 x 8000 = 64KB ****
c GȌnꍇɂ́C̏𑝂₹΂悢
c
      implicit real*8 (a-h,o-z)
      character*70 title
      character*3  job,endjob
      common / mem1 / a(mtop)
      common / mem2 / b(mtop)
      common / mem3 / n(mtop)
      common pi
      equivalence (title,job)
      data endjob / 'end' /
c
      pi=4.d0*atan(1.d0)
      open(5,file='frame.dat')
      write(6,200)
c
c one case starts here **********************************************
c
   30 continue
      read(5,500) title
      write(6,600) title
      if( job.eq.endjob ) go to 20
c
c basic data input **************************************************
c
      read(5,400) node,nel,ee
      nn=3*node
      write(6,100) node,nel,ee
c
c address setting ***************************************************
c
      n1=1
      n2=n1+nn*nn
      n3=n2+nn
      na4=n3+2*node
      nlast1=na4+nn
      n4=n3+nel
      n5=n4+nel
      n6=n5+nel
      nlast2=n6+nel-1
      if( nlast1.le.mtop.and.nlast2.le.mtop ) go to 10
      write(6,300) nlast1,nlast2,mtop
      go to 20
   10 continue
      m1=1
      m2=m1+nn
      m3=m2+2*nel
c
c real main routine *************************************************
c
      call cframe ( a(n1),a(n2),a(n3),a(na4),
     *                    b(n1),b(n2),b(n3),b(n4),b(n5),b(n6),
     *                             n(m1),n(m2),n(m3),ee,node,nel,nn )
      go to 30
c
   20 continue
      close (5)
      stop 'End of FEM/plane frame/ program...'
c
  100 format(' ','# of nodes =',i5,' :',16x,'# of elements =',i5/
     *       ' ',' Young-s modulus (E0) =',1pd15.7,8x,
     *           '(r-dir counterclockwise)'/)
  200 format(' ','FEM/plane frame/',52x,'07-21-1996'/)
  300 format(' ','Either nlast1(',i5,') or nlast2(',i5,') is larger',
     *           ' than mtop(',i5,').'/
     *       ' ','Cannot carry out calculation!')
  400 format(2i5,f10.0)
  500 format(a70)
  600 format(/' ',70('-')/' ',a70/' ',70('-'))
      end
c
c real main routine *************************************************
c
      subroutine cframe ( s,f,x,fdist,sr,fr,re,area,smom,gdist,
     *                               ind,nbar,ngeobc,ee,node,nel,nn )
c
      implicit real*8 (a-h,o-z)
      character*1 dir(3)
      dimension s(nn,nn),f(nn),x(2,node),sr(nn,nn),fr(nn)
      dimension re(nel),area(nel),ind(nn),nbar(2,nel),sl(6,6)
      dimension smom(nel),fdist(nn),ngeobc(nn),gdist(nel)
      common pi
      data dir / 'x', 'z', 'r' /
c
c node data/ element data *******************************************
c
      do 10 i=1,node
      call coord (x(1,i),i)
   10 continue
      write(6,100)
      do 15 i=1,nel
      gdist(i)=0.d0
      call nodel (nbar(1,i),re(i),area(i),smom(i),i)
   15 continue
c
      do 35 i=1,nn
      fdist(i)=0.d0
      ngeobc(i)=0
      do 35 j=1,nn
      s(i,j)=0.d0
      sr(i,j)=0.d0
   35 continue
c
c local and global stiffness matrices *******************************
c
      do 20 i=1,nel
      call locals ( x(1,nbar(1,i)),x(1,nbar(2,i)),
     *                                     re(i),area(i),smom(i),sl )
      do 20 j=1,2
      j0=3*j-2
      jj=3*nbar(j,i)-2
      do 20 k=1,2
      k0=3*k-2
      kk=3*nbar(k,i)-2
      do 20 l=0,2
      do 20 m=0,2
      s(jj+l,kk+m)=s(jj+l,kk+m)+sl(j0+l,k0+m)
   20 continue
      do 25 i=1,nn
      do 25 j=1,nn
      sr(i,j)=s(i,j)
   25 continue
c
c displacement boundary conditions ****************************
c
      read(5,500) ndis
      write(6,200) ndis
      do 30 i=1,ndis
      read(5,500) j,k,ff
      write(6,300) dir(k),j,ff
      m=3*j-3+k
      do 40 l=1,nn
      if( ngeobc(l).ne.1 ) fdist(l)=fdist(l)-ff*ee*s(l,m)
      s(m,l)=0.d0
      s(l,m)=0.d0
   40 continue
      s(m,m)=1.d0
      ngeobc(m)=1
      fdist(m)=ff*ee
   30 continue
c
c lu decomposition
c
      call ludcmp(s,f,ind,nn)
c
      do 50 i=1,nn
      f(i)=fdist(i)
      fdist(i)=0.d0
   50 continue
c
c force boundary conditions *****************************************
c
      read(5,500) nforc
      write(6,400) nforc
      do 60 i=1,nforc
      read(5,500) j,k,ff
      write(6,600) dir(k),j,ff
      m=3*j-3+k
      f(m)=ff
   60 continue
c
c distributed loads
c
      read(5,500) ndist
      write(6,450) ndist
      do 65 i=1,ndist
      read(5,550) j,ff
      write(6,650) j,ff
      gdist(j)=ff
      call angle ( x(1,nbar(1,j)),x(1,nbar(2,j)),th,tlen )
      ct=cos(th)
      j1=3*nbar(1,j)-3
      j2=3*nbar(2,j)-3
      gg=tlen*ff/2.d0
      fdist(j1+2)=fdist(j1+2)+gg
      if( ngeobc(j1+2).ne.1 ) f(j1+2)=f(j1+2)+gg
      fdist(j2+2)=fdist(j2+2)+gg
      if( ngeobc(j2+2).ne.1 ) f(j2+2)=f(j2+2)+gg
      gg=-tlen**2*ff*ct/12.d0
      fdist(j1+3)=fdist(j1+3)+gg
      if( ngeobc(j1+3).ne.1 ) f(j1+3)=f(j1+3)+gg
      fdist(j2+3)=fdist(j2+3)-gg
      if( ngeobc(j2+3).ne.1 ) f(j2+3)=f(j2+3)-gg
   65 continue
c
c solve it !! *******************************************************
c
      call lubksb(s,f,ind,nn)
c
c displacement output ***********************************************
c
      write(6,700)
      do 70 i=1,node
      j=3*i-2
      write(6,800) i,f(j)/ee,f(j+1)/ee,f(j+2)/ee
   70 continue
c
c stress/strain output
c
      write(6,900)
      do 80 i=1,nel
      i1=3*nbar(1,i)-2
      i2=3*nbar(2,i)-2
      call localr ( x(1,nbar(1,i)),x(1,nbar(2,i)),re(i),area(i),
     *     smom(i),gdist(i),sl,f(i1),f(i2),ee,i,nbar(1,i),nbar(2,i) )
   80 continue
c
c reaction forces
c
      write(6,950)
      do 90 i=1,nn
      fr(i)=-fdist(i)
      do 90 j=1,nn
      fr(i)=fr(i)+sr(i,j)*f(j)
   90 continue
      do 95 i=1,node
      j=3*i-2
      write(6,800) i,fr(j),fr(j+1),fr(j+2)
   95 continue
c                     ***********************************************
      return
c
  100 format()
  200 format(/' ','# of given displacements =',i5)
  300 format(' ',5x,a1,'-component at node #',i5,' : (value=',
     *       1pd15.7,')')
  400 format(/' ','# of given forces        =',i5)
  450 format(/' ','# of elements with uniformly distributed loads',
     *            ' in z-direction =',i5)
  500 format(2i5,f10.0)
  550 format(i5,f10.0)
  600 format(' ',5x,a1,'-component at node #',i5,' : (value=',
     *       1pd15.7,')')
  650 format(' ',5x,'Uniformly distributed load in element #',i5,
     *       ' : (value=',1pd15.7,')')
  700 format(/' ','----- RESULTS OUTPUT -----'/
     *        ' ','Displacement:'/' ','  Node',7x,'x-dir',10x,'z-dir',
     *        10x,'r-dir')
  800 format(' ',i5,2x,1p3d15.7)
  900 format(/' ','Stress/Strain:',13x,
     *            '(Extension=N/EA, Bending=cM/EI, c=sqrt[I/A])'/
     *        ' ','Elmt',2x,'Node',4x,'Tension',
     *            5x,'Extension',6x,'Shear',7x,'Moment',6x,'Bending')
  950 format(/' ','Reaction (or Applied) forces:'/
     *        ' ','  Node',7x,'x-dir',10x,'z-dir',10x,'r-dir')
      end
c
c input node no. and its coordinates ********************************
c
      subroutine coord (x,node)
c
      implicit real*8 (a-h,o-z)
      dimension x(2)
c
      read(5,100) x(1),x(2)
      write(6,200) node,x(1),x(2)
      return
c
  100 format(2f10.0)
  200 format(' ','Node no.',i5,' :  x=',1pd15.7,'  z=',d15.7)
      end
c
c input node no. of one element *************************************
c
      subroutine nodel (nbar,re,area,smom,nel)
      implicit real*8 (a-h,o-z)
c
      dimension nbar(2)
      read(5,100) nbar(1),nbar(2),re,area,smom
      write(6,200) nel,nbar(1),nbar(2),re,area,smom
      return
c
  100 format(2i5,3f10.0)
  200 format(' ','Elmt no.',i5,' [',i5,' -',i5,' ]  : E/E0 =',
     *           1pd15.7/
     *       ' ',10x,'Area =',d15.7,',    Moment of Inertia =',d15.7)
      end
c
c form local stiffness matrix ***************************************
c
      subroutine locals ( x1,x2,re,area,smom,sl )
c
      implicit real*8 (a-h,o-z)
      dimension x1(2),x2(2),sl(6,6),tt(3,3),ss(3,3),st(3,3)
c
      call angle ( x1,x2,th,tlen )
      call sincos ( tt,th )
c
      call stiffa ( ss,re,area,smom,tlen,tt,st )
      do 20 i=1,3
      do 20 j=1,3
      sl(i,j)=0.d0
      do 20 k=1,3
      sl(i,j)=sl(i,j)+tt(k,i)*st(k,j)
   20 continue
c
      call stiffb ( ss,re,area,smom,tlen,tt,st )
      do 40 i=1,3
      do 40 j=1,3
      sl(i+3,j+3)=0.d0
      do 40 k=1,3
      sl(i+3,j+3)=sl(i+3,j+3)+tt(k,i)*st(k,j)
   40 continue
c
      call stiffc ( ss,re,area,smom,tlen,tt,st,1 )
      do 60 i=1,3
      do 60 j=1,3
      sl(i,j+3)=0.d0
      do 60 k=1,3
      sl(i,j+3)=sl(i,j+3)+tt(k,i)*st(k,j)
   60 continue
c
      do 70 i=1,3
      do 70 j=1,3
      sl(j+3,i)=sl(i,j+3)
   70 continue
c
      return
      end
c
      subroutine sincos ( tt,th )
c
      implicit real*8 (a-h,o-z)
      dimension tt(3,3)
c
      ct=cos(th)
      st=sin(th)
c
      tt(1,1)=ct
      tt(1,2)=-st
      tt(1,3)=0.d0
      tt(2,1)=st
      tt(2,2)=ct
      tt(2,3)=0.d0
      tt(3,1)=0.d0
      tt(3,2)=0.d0
      tt(3,3)=1.d0
c
      return
      end
c
      subroutine stiffa ( ss,re,area,smom,tlen,tt,st )
c
      implicit real*8 (a-h,o-z)
      dimension tt(3,3),ss(3,3),st(3,3)
c
      ss(1,1)=re*area/tlen
      ss(1,2)=0.d0
      ss(1,3)=0.d0
      ss(2,1)=0.d0
      ss(2,2)=12.d0*re*smom/tlen**3
      ss(2,3)=-6.d0*re*smom/tlen**2
      ss(3,1)=0.d0
      ss(3,2)=ss(2,3)
      ss(3,3)=4.d0*re*smom/tlen
      do 10 i=1,3
      do 10 j=1,3
      st(i,j)=0.d0
      do 10 k=1,3
      st(i,j)=st(i,j)+ss(i,k)*tt(k,j)
   10 continue
c
      return
      end
c
      subroutine stiffb ( ss,re,area,smom,tlen,tt,st )
c
      implicit real*8 (a-h,o-z)
      dimension tt(3,3),ss(3,3),st(3,3)
c
      ss(2,3)=6.d0*re*smom/tlen**2
      ss(3,2)=ss(2,3)
      do 10 i=1,3
      do 10 j=1,3
      st(i,j)=0.d0
      do 10 k=1,3
      st(i,j)=st(i,j)+ss(i,k)*tt(k,j)
   10 continue
c
      return
      end
c
      subroutine stiffc ( ss,re,area,smom,tlen,tt,st,ind )
c
      implicit real*8 (a-h,o-z)
      dimension tt(3,3),ss(3,3),st(3,3)
c
      ss(1,1)=-re*area/tlen
      ss(2,2)=-12.d0*re*smom/tlen**3
      ss(2,3)=-6.d0*re*smom/tlen**2
      if( ind.lt.0 ) ss(2,3)=-ss(2,3)
      ss(3,2)=-ss(2,3)
      ss(3,3)=2.d0*re*smom/tlen
      do 10 i=1,3
      do 10 j=1,3
      st(i,j)=0.d0
      do 10 k=1,3
      st(i,j)=st(i,j)+ss(i,k)*tt(k,j)
   10 continue
c
      return
      end
c
      subroutine angle ( x1,x2,th,tlen )
      implicit real*8 (a-h,o-z)
      common pi
      dimension x1(2),x2(2)
c
      thx=x2(1)-x1(1)
      thy=x1(2)-x2(2)
      if( abs(thx).le.1.d-36 ) then
          th=thy*pi/2.d0/abs(thy)
      else
          th=atan(thy/thx)
          if( thx.lt.0.d0 ) th=pi+th
      end if
      tlen=sqrt(thx*thx+thy*thy)
c
      return
      end
c
c tension/extension calculation *************************************
c
      subroutine localr ( x1,x2,re,area,smom,gdist,
     *                                        sl,d1,d2,ee,iel,n1,n2 )
c
      implicit real*8 (a-h,o-z)
      dimension x1(2),x2(2),d1(3),d2(3),sl(6,6)
      dimension ss(3,3),tt(3,3),dd(6),ff(6),st(3,3)
c
      call angle ( x1,x2,th,tlen )
      call sincos ( tt,th )
c
      do 20 i=1,3
      dd(i)=d1(i)
      dd(i+3)=d2(i)
   20 continue
c
      call stiffa ( ss,re,area,smom,tlen,tt,st )
      do 10 i=1,3
      do 10 j=1,3
      sl(i,j)=st(i,j)
   10 continue
c
      call stiffb ( ss,re,area,smom,tlen,tt,st )
      do 30 i=1,3
      do 30 j=1,3
      sl(i+3,j+3)=st(i,j)
   30 continue
c
      call stiffc ( ss,re,area,smom,tlen,tt,st,1 )
      do 50 i=1,3
      do 50 j=1,3
      sl(i,j+3)=st(i,j)
   50 continue
c
      call stiffc ( ss,re,area,smom,tlen,tt,st,-1 )
      do 70 i=1,3
      do 70 j=1,3
      sl(i+3,j)=st(i,j)
   70 continue
c
      gp=-gdist*sin(th)
      gq=gdist*cos(th)
      ff(1)=-gp*tlen/2.d0
      ff(2)=-gq*tlen/2.d0
      ff(3)=gq*tlen**2/12.d0
      ff(4)=ff(1)
      ff(5)=ff(2)
      ff(6)=-ff(3)
c
      do 40 i=1,6
      do 40 j=1,6
      ff(i)=ff(i)+sl(i,j)*dd(j)
   40 continue
c
      rrr=sqrt(area*smom)
      write(6,100) iel,n1,-ff(1),-ff(1)/re/ee/area,-ff(2),
     *                                     -ff(3),-ff(3)/re/ee/rrr
      write(6,200) n2,ff(4),ff(4)/re/ee/area,ff(5),
     *                                      ff(6),ff(6)/re/ee/rrr
c
      return
c
  100 format(' ',i3,2x,i3,2x,1p5d13.5)
  200 format(' ',5x,i3,2x,1p5d13.5)
      end
c
c  from "NUMERICAL RECIPES" by W.H.Press et al. *********************
c  for LU decomposition of matrix a(n,n)
c
      subroutine ludcmp (a,w,ind,n)
c
      implicit real*8 (a-h,o-z)
      dimension a(n,n),w(n),ind(n)
c                      w : working area
      data tiny / 1.d-20 /
c
      do 20 i=1,n
      aamax=0.d0
      do 10 j=1,n
      if( abs(a(i,j)).gt.aamax ) aamax=abs(a(i,j))
   10 continue
      if( aamax.eq.0.d0 ) stop
      w(i)=1.d0/aamax
   20 continue
      do 90 j=1,n
      do 40 i=1,j-1
      sum=a(i,j)
      do 30 k=1,i-1
      sum=sum-a(i,k)*a(k,j)
   30 continue
      a(i,j)=sum
   40 continue
      aamax=0.d0
      do 60 i=j,n
      sum=a(i,j)
      do 50 k=1,j-1
      sum=sum-a(i,k)*a(k,j)
   50 continue
      a(i,j)=sum
      dum=w(i)*abs(sum)
      if( dum.ge.aamax ) then
        imax=i
        aamax=dum
      endif
   60 continue
      if( j.ne.imax ) then
        do 70 k=1,n
        dum=a(imax,k)
        a(imax,k)=a(j,k)
        a(j,k)=dum
   70   continue
        w(imax)=w(j)
      endif
      ind(j)=imax
      if( a(j,j).eq.0.d0 ) a(j,j)=tiny
      if( j.ne.n ) then
        dum=1.d0/a(j,j)
        do 80 i=j+1,n
        a(i,j)=a(i,j)*dum
   80   continue
      endif
   90 continue
      return
      end
c
c  from "NUMERICAL RECIPES" by W.H.Press et al. *********************
c
c  to solve linear algebraic equation ax=b by LU decomposition
c     "x" will be stored in "b"
c
      subroutine lubksb (a,b,ind,n)
c
      implicit real*8 (a-h,o-z)
      dimension a(n,n),b(n),ind(n)
      ii=0
      do 20 i=1,n
      ll=ind(i)
      sum=b(ll)
      b(ll)=b(i)
      if( ii.ne.0 ) then
        do 10 j=ii,i-1
        sum=sum-a(i,j)*b(j)
   10   continue
      else if( sum.ne.0.d0 ) then
        ii=i
      endif
      b(i)=sum
   20 continue
      do 40 i=n,1,-1
      sum=b(i)
      if( i.lt.n ) then
        do 30 j=i+1,n
        sum=sum-a(i,j)*b(j)
   30   continue
      endif
      b(i)=sum/a(i,i)
   40 continue
      return
      end
